package w83b.w83bOperacionesPaso.w83bComunicaciones;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import w83b.w83bBeans.W83bComunicacionesBean;
import w83b.w83bBeans.W83bDocBean;
import w83b.w83bBeans.W83bPlantillasBean;
import w83b.w83bBeans.W83bUsuarioXLNetsBean;
import w83b.w83bUtilidades.W83bUtilidadesComunes;
import w83b.w83bUtilidades.W83bUtilidadesRTF;
import w83b.w83bUtilidadesComunes.W83bClsConstantes;
import w83b.w83bUtilidadesComunes.W83bClsTrazas;
import w83b.w83bUtilidadesComunes.W83bDateUtil;
import w83b.w83bUtilidadesLibroRegistro.W83bLibroRegistro;
import w83b.w83bUtilidadesLibroRegistro.W83bLibroRegistroException;
import es.ejie.frmk.infraestructura.internacionalizacion.Q70GestorMensajesi18n;
import es.ejie.frmk.presentacion.operacion.paso.Q70ActionPasoOP;
import es.ejie.frmk.presentacion.sesiondatos.Q70ContextoEJIE;

public class W83bGenerarRtfComunicacionActionAlt extends Q70ActionPasoOP{


	
	protected void processOP(Q70ContextoEJIE contexto, ActionErrors errores, ActionMapping mapping,
			ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		
	}

	protected ActionForward processForward(Q70ContextoEJIE contexto, ActionErrors errors, ActionMapping mapping, 
			ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		//String strRutaRtf ="";// Q70ListenerUtils.getApplicationProperty("RUTA_PLANTILLAS_RTF")+"plantillaCertNumDelCentSind.rtf";
		

	    List lista=(List)contexto.get("w83bResultadoBean");
		
		StringBuffer observaciones=new StringBuffer(W83bClsConstantes.CUARENTA);
		

		int tamanyo = 25;

		if(lista.size()-1<25){
			tamanyo = lista.size()-1;
		}
		
		if(tamanyo>=1){
		
			String idioma=(String)contexto.get(W83bClsConstantes.CONSTANTE_CONTEXTO_IDIOMA);
			W83bUsuarioXLNetsBean usuario=(W83bUsuarioXLNetsBean)contexto.get(W83bClsConstantes.CONSTANTE_CONTEXTO_USUARIO);
	        HashMap datosDelDep=  W83bUtilidadesComunes.obtenerTitulosDelegacionDepartamento(usuario,idioma);  	
        	
        
		//strRutaRtf = Q70ListenerUtils.getApplicationProperty("RUTA_PLANTILLAS_RTF")+"plantillaComunPreaviso.rtf";
		HashMap generarRtf = (HashMap)contexto.get("generarRtf");
		if(null==generarRtf){
			generarRtf = new HashMap();
		}
		HashMap mapaPar = new HashMap();
		HashMap mapaParGeneral = new HashMap();
		mapaParGeneral.put("<<DEPEUS>>",((StringBuffer)datosDelDep.get("tituloDepEu")).toString());
		mapaParGeneral.put("<<DEPCAS>>",((StringBuffer)datosDelDep.get("tituloDepEs")).toString());
		mapaParGeneral.put("<<DELEUS>>",((StringBuffer)datosDelDep.get("tituloDelelegacionEu")).toString());
		mapaParGeneral.put("<<DELCAS>>",((StringBuffer)datosDelDep.get("tituloDelelegacionEs")).toString());
		mapaParGeneral.put("<<DIRDELEGACION>>",(String)datosDelDep.get("dirdelegacion"));
		
		HashMap mapaPlantillas = (HashMap)contexto.get("w83bPlantillasMap");
		byte[] plantilla = ((W83bPlantillasBean)mapaPlantillas.get(W83bClsConstantes.NOTIFICACION_EMPRESA_PREAVISO.toUpperCase())).getFichero();
		
		CharSequence content=W83bUtilidadesRTF.leerTodoFichero(plantilla);
		String contenido=content.toString();

		StringBuffer contenidoBuffer=new StringBuffer(contenido);
		int ifooter=contenido.lastIndexOf("footer");
		String delantefooter=contenido.substring(ifooter,contenido.length());
		int ifooterLlave=delantefooter.indexOf("}")+2;
		int finDelantelimpio=ifooter+ifooterLlave;
		int z=contenido.lastIndexOf("page")+6;
		StringBuffer parteDelanteLimpia=new StringBuffer(contenido.substring(0,finDelantelimpio));
		String parteAtrasLimpia=contenido.substring(z,contenido.length());
		contenidoBuffer=new StringBuffer(contenido.substring(finDelantelimpio,z));
		
		parteDelanteLimpia=W83bUtilidadesRTF.sustituirCadenaCaracteresString(parteDelanteLimpia, mapaParGeneral);
		List datosLst = (ArrayList)contexto.get("documento");
		int tamanyoTotal = 0;
		if(datosLst.size()>0){
			tamanyoTotal = Integer.parseInt((String)datosLst.get(datosLst.size()-1));
			datosLst.remove(datosLst.size()-1);
			datosLst.remove(datosLst.size()-1);
		}else{
			datosLst.add(parteDelanteLimpia);
			tamanyoTotal = tamanyoTotal + parteDelanteLimpia.toString().getBytes().length;			
		}
		
		List comunicind=new ArrayList();
		W83bDocBean docBean= new W83bDocBean();
		StringBuffer elemento=new StringBuffer();
		StringBuffer elementoind=new StringBuffer();
		int tamnyo = 0;
		for(int i=0;i<tamanyo;i++)
		{		
			StringBuffer datosind=new StringBuffer();//NOPMD
			datosind.append(parteDelanteLimpia);
			mapaPar.put("<<DEPEUS>>",((StringBuffer)datosDelDep.get("tituloDepEu")).toString());
			mapaPar.put("<<DEPCAS>>",((StringBuffer)datosDelDep.get("tituloDepEs")).toString());
			mapaPar.put("<<DELEUS>>",((StringBuffer)datosDelDep.get("tituloDelelegacionEu")).toString());
			mapaPar.put("<<DELCAS>>",((StringBuffer)datosDelDep.get("tituloDelelegacionEs")).toString());
			mapaPar.put("<<DIRDELEGACION>>",(String)datosDelDep.get("dirdelegacion"));
			W83bComunicacionesBean comunic=(W83bComunicacionesBean)lista.get(i);

			
			observaciones=new StringBuffer(W83bClsConstantes.CUARENTA);//NOPMD
			observaciones.append(Q70GestorMensajesi18n.getSingleton().getMessage("w83bcomun","comun.comunicaciones.notifemppre",comunic.getIdioma(),null)).append(" ");
			observaciones.append(comunic.getNumpreaviso());
				
			long milisegundos = System.currentTimeMillis();
			String [] resul = null;
			try{
				resul=W83bLibroRegistro.getAltaRegistro(true, comunic.getUsuarioBean().getModeloSal(), "S", "E", Q70GestorMensajesi18n.getSingleton().getMessage("w83bcomun","comun.informes.direccionTrabajo_es",comunic.getIdioma(),null), comunic.getTerrit(), "" ,observaciones.toString(), comunic.getUsuarioBean());
			}catch(W83bLibroRegistroException e){
				generarRtf = (HashMap)contexto.get("generarRtf");
					if(null==generarRtf){
						generarRtf = new HashMap(); //NOPMD
					}
					generarRtf.put("error", "errorLibroRegistro");
					contexto.set("generarRtf",generarRtf);
				  return mapping.findForward("fin"); 
			}
			W83bClsTrazas.trazaError(comunic.getUsuarioBean(), "tiempo antes de query="+(System.currentTimeMillis()- milisegundos), null);
			comunic.setNumsalida(resul[0]);
			comunic.setFechaaregistro(resul[1]);

			
			mapaPar.put("<<NUMSALIDA>>",W83bUtilidadesRTF.ponerBlancoANulo(comunic.getNumsalida()));
			List fa;
			if (W83bClsConstantes.CONSTANTE_CASTELLANO.equals(idioma)){
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechacomunicacion(),W83bClsConstantes.CONSTANTE_CASTELLANO);
			}
			else{
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechacomunicacion(),W83bClsConstantes.CONSTANTE_EUSKARA);
			}
			mapaPar.put("<<FECHA>>",W83bDateUtil.getInstance().devolverLiteralfechamin(Integer.parseInt((String)fa.get(0)),Integer.parseInt((String)fa.get(1)),Integer.parseInt((String)fa.get(2)),idioma).toString());
			mapaPar.put("<<RAZON>>",comunic.getRazon());
			if (W83bClsConstantes.CONSTANTE_NO_VALIDADA.equals(comunic.getCentroSel())||StringUtils.isEmpty(comunic.getDirorig())){
				mapaPar.put("<<DOMIC>>",W83bUtilidadesRTF.ponerBlancoANulo(comunic.getDomicilio()));
			}
			else{
				mapaPar.put("<<DOMIC>>",W83bUtilidadesRTF.ponerBlancoANulo(comunic.getDirorig()));
			}
			if (W83bClsConstantes.CONSTANTE_NO_VALIDADA.equals(comunic.getCentroSel())||StringUtils.isEmpty(comunic.getCporig())){
				mapaPar.put("<<CPOST>>",comunic.getCodigopostal());
			}
			else{
				mapaPar.put("<<CPOST>>",comunic.getCporig());
			}
			
			mapaPar.put("<<LOCAL>>",W83bUtilidadesRTF.ponerBlancoANulo(comunic.getMunicipio()).toUpperCase());
			
			mapaPar.put("<<PROV>>",comunic.getProvincia().toUpperCase());
			
			mapaPar.put("<<EXPDTE>>",Q70GestorMensajesi18n.getSingleton().getMessage("w83bcomun","comun.preavisos.tabla.num_preaviso",idioma,null)+":"+comunic.getNumpreaviso());	

			if (W83bClsConstantes.CONSTANTE_CASTELLANO.equals(idioma)){
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechaentrada(),W83bClsConstantes.CONSTANTE_CASTELLANO);
			}
			else{
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechaentrada(),W83bClsConstantes.CONSTANTE_EUSKARA);
			}
			mapaPar.put("<<ANNO>>",fa.get(2));	
			mapaPar.put("<<MES>>",W83bDateUtil.getInstance().sabernombremesmin(Integer.parseInt((String)fa.get(1))-1,W83bClsConstantes.CONSTANTE_EUSKARA));	
			mapaPar.put("<<DIA>>",fa.get(0));	
			mapaPar.put("<<FENTRADA>>",W83bDateUtil.getInstance().devolverLiteralfechaentera(Integer.parseInt((String)fa.get(0)),Integer.parseInt((String)fa.get(1)),Integer.parseInt((String)fa.get(2)),W83bClsConstantes.CONSTANTE_CASTELLANO).toString());
			mapaPar.put("<<LOCALID>>",usuario.getLocalidadTxtCastDelegacionMin());
			if (W83bClsConstantes.CONSTANTE_CASTELLANO.equals(idioma)){
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechacomunicacion(),W83bClsConstantes.CONSTANTE_CASTELLANO);
			}
			else{
				fa=W83bDateUtil.getInstance().separarDiaMesAnyo(comunic.getFechacomunicacion(),W83bClsConstantes.CONSTANTE_EUSKARA);
			}
			mapaPar.put("<<FECCAS>>"," a "+W83bDateUtil.getInstance().devolverLiteralfechaentera(Integer.parseInt((String)fa.get(0)),Integer.parseInt((String)fa.get(1)),Integer.parseInt((String)fa.get(2)),W83bClsConstantes.CONSTANTE_CASTELLANO).toString());
			mapaPar.put("<<FECUSK>>",W83bDateUtil.getInstance().devolverLiteralfechaentera(Integer.parseInt((String)fa.get(0)),Integer.parseInt((String)fa.get(1)),Integer.parseInt((String)fa.get(2)),W83bClsConstantes.CONSTANTE_EUSKARA).toString());
			mapaPar.put("<<CARGOEU>>",comunic.getDescfirmanteeu().toUpperCase());
			mapaPar.put("<<LINEAORDEN>>","");
			mapaPar.put("<<DELEGADO>>",W83bUtilidadesRTF.ponerBlancoANulo(comunic.getNombrefirmante()));
			mapaPar.put("<<PROVI>>",comunic.getDescTerritorio().toUpperCase());
			mapaPar.put("<<CARGO>>",comunic.getDescfirmante().toUpperCase());
			mapaPar.put("<<LINEARESPONSABLE>>","");
			elementoind=W83bUtilidadesRTF.sustituirCadenaCaracteresString(contenidoBuffer, mapaPar);
			elemento=W83bUtilidadesRTF.sustituirCadenaCaracteresString(contenidoBuffer, mapaPar);
			String delante="";
			String delanteL="";
			String detras="";
			String detrasL="";
			if (i==lista.size()-2){
				int j=elemento.lastIndexOf("page");
				delante=elemento.substring(0,j);
				delanteL=delante.substring(0, delante.lastIndexOf("{"));
				detras=elemento.substring(j,elemento.length());
				detrasL=detras.substring( detras.indexOf("}")+1,detras.length());
				elemento=new StringBuffer(delanteL.concat(detrasL));//NOPMD
			}
			
			int k=elementoind.lastIndexOf("page");
			delante=elementoind.substring(0,k);
			delanteL=delante.substring(0, delante.lastIndexOf("{"));
			detras=elementoind.substring(k,elementoind.length());
			detrasL=detras.substring( detras.indexOf("}")+1,detras.length());
			elementoind=new StringBuffer(delanteL.concat(detrasL));//NOPMD

				tamnyo = tamnyo + elemento.toString().length();
				W83bClsTrazas.trazaError(null,"tamanyo->"+i+" datoslst->"+tamnyo,null);
				datosLst.add(elemento);
				tamanyoTotal = tamanyoTotal + elemento.toString().getBytes().length;
			datosind.append(elementoind);
			datosind.append(parteAtrasLimpia);
			docBean=  W83bUtilidadesComunes.obtenerInformacionDocumento(comunic,datosind,"ComunicacionPreaviso"+comunic.getNumpreaviso()+".rtf",String.valueOf(W83bClsConstantes.UNO),String.valueOf(W83bClsConstantes.TRES),"preaviso");
			comunicind.add(docBean);
			datosind = null;
			docBean = null;
			
		    Runtime garbage = Runtime.getRuntime();
		    W83bClsTrazas.trazaError(null,"Memoria libre antes de limpieza: "+ garbage.freeMemory(),null);
		    System.runFinalization();
		    System.gc();  	   
		    garbage.gc();
		    W83bClsTrazas.trazaError(null,"Memoria libre después de limpieza: "+ garbage.freeMemory(),null);
		}
	
		datosLst.add(parteAtrasLimpia);
		tamanyoTotal = tamanyoTotal + parteAtrasLimpia.toString().getBytes().length;
		datosLst.add(String.valueOf(tamanyoTotal));
		
		contexto.set("documento",datosLst);
	    generarRtf.put("comunicind", null);
	    String tam = "";
	    int tamInt = 0;
	    if(null!=generarRtf){
	    	tam = (String)generarRtf.get("tam");
	    	if(StringUtils.isNotEmpty(tam)){
	    		tamInt = Integer.parseInt(tam);
	    	}
	    }
	    tamInt = tamInt + tamanyo;
	    generarRtf.put("tam", String.valueOf(tamInt));
	    contexto.set("generarRtf", generarRtf);
	    contexto.set("w83bListaInd", comunicind);
	
		
			generarRtf.put("comunicind",comunicind);
			contexto.set("generarRtf",generarRtf);
	    
	    List listatemp = lista.subList(tamanyo,lista.size());
	    
	    lista = new ArrayList();
	    lista.addAll(listatemp);
	    
	    contexto.set("w83bResultadoBean",lista);
	    

		Runtime garbage = Runtime.getRuntime();
	    W83bClsTrazas.trazaError(null,"ending Action - Memoria libre antes de limpieza: "+ garbage.freeMemory(),null);
	    System.runFinalization();
	    System.gc();  	   
	    garbage.gc();
	    W83bClsTrazas.trazaError(null,"ending Action - Memoria libre después de limpieza: "+ garbage.freeMemory(),null);


	   
	    return mapping.findForward("ok");
		}else{
			return mapping.findForward("fin");
		}
	    
	    
	}
}

